
/*******************************************************************
 * This program gets a binary number, then converts it to decimal. Next,
 * it gets a decimal number from the keyboard, and converts it to 
 * binary.
 *******************************************************************/
#include <stdio.h>
#include <string.h>
int bin_to_decimal(char bits[]);/* This function takes a string of 
				   bits and returns the corresponding
				   decimal integer. If it encounters an 
				   invalid bit, it returns -1.
				   */
char* reverse(char word[]);/* This function reverses the 
			     string 'word'
			     */

char* dec_to_binary(int num, char bits[]);
/* The function above converts the decimal num to binary bits,
 * stores the result in 'bits', and returns the pointer to bits.
 * */
int main(void)
{
	char bi_num[17];
	int dec_num,temp,i;
	printf("Please enter whole number in binary:");
	scanf("%14s", bi_num);
	dec_num=bin_to_decimal(bi_num);
	if(dec_num!=-1)
		printf("%s%s%d",bi_num, " in base 10 is ",dec_num);

	printf("\n\nPlease enter whole number in decimal notation:");

	scanf("%d",&dec_num);
	dec_to_binary(dec_num,bi_num);
	printf("%d%s%s\n",dec_num," in base 2 is ", bi_num);
	return 0;
}

/* Take a string of bits and returns the corresponding
   decimal integer. If it encounters an invalid bit, it 
   returns -1.*/
int bin_to_decimal(char bits[]){
	int i;
	int in_decimal=0;
	for(i=0;i<strlen(bits);i++)
	{
		if(bits[i]=='0')
			in_decimal=in_decimal*2;
		else if(bits[i]=='1')
			in_decimal=in_decimal*2+1;
		else /* The character is not 1 or 0. */
		{
			printf("%s%s%c", bits, " is invalid. It has a ", 
					bits[i]);
			in_decimal=-1;
		}
	}

		
	return in_decimal;
}

/* Reverse a string. */
char* reverse(char word[]){
	int i, length=strlen(word);
	char temp;
	for(i=0;i<length/2;i++)
	{
		temp=word[i];
		word[i]=word[length-i-1];
		word[length-i-1]=temp;
	}
	return word;
}
/* The function below converts the decimal num to binary bits,
 * stores the result in 'bits', and returns the pointer to bits.
 */	
char* dec_to_binary(int num, char bits[]){
	bits[0]='\0';/* This holds the binary representation, 
			 * reversed, initially */
	int temp=num;
	while(temp>0)
	{
		if(temp%2==0)
			strcat(bits,"0");
		else
			strcat(bits,"1");
		temp=temp/2;
	}

	reverse(bits);
	return bits;
}
	
